#ifndef __GPIO_H
#define __GPIO_H

#ifdef __cplusplus
extern "C" {
#endif
#ifdef __GPIO_H_GLOBAL
#define __GPIO_H_EXTERN
#else
#define __GPIO_H_EXTERN extern
#endif

/************************************************************************************************
 *                                          Version                                             *
 ************************************************************************************************/

/************************************************************************************************
 *                                          How to use                                          *
 ************************************************************************************************/

/************************************************************************************************
 *                                          Enable config                                        *
 ************************************************************************************************/

/************************************************************************************************
 *                                          Includes                                            *
 ************************************************************************************************/

#include "stm32f4xx.h"

/************************************************************************************************
 *                                          Defines                                              *
 ************************************************************************************************/

#define GPIO_BEEP_PORT         GPIOF
#define GPIO_BEEP_PIN          GPIO_Pin_8
#define GPIO_LED1_PORT         GPIOF
#define GPIO_LED1_PIN          GPIO_Pin_10
#define GPIO_KEY_UP_PORT       GPIOA
#define GPIO_KEY_UP_PIN        GPIO_Pin_0
#define GPIO_KEY0_PORT         GPIOE
#define GPIO_KEY0_PIN          GPIO_Pin_4
#define GPIO_KEY1_PORT         GPIOE
#define GPIO_KEY1_PIN          GPIO_Pin_3
#define GPIO_KEY2_PORT         GPIOE
#define GPIO_KEY2_PIN          GPIO_Pin_2
#define GPIO_LED1(on_off)      ((on_off == 0) ? (GPIO_ResetBits(GPIO_LED1_PORT, GPIO_LED1_PIN)) : (GPIO_SetBits(GPIO_LED1_PORT, GPIO_LED1_PIN)))
#define GPIO_BEEP(beep_status) ((beep_status == 0) ? (GPIO_ResetBits(GPIO_BEEP_PORT, GPIO_BEEP_PIN)) : (GPIO_SetBits(GPIO_BEEP_PORT, GPIO_BEEP_PIN)))

/************************************************************************************************
 *                                          Typedefs                                            *
 ************************************************************************************************/

/************************************************************************************************
 *                                          Interfaces                                          *
 ************************************************************************************************/
void gpio_init(void);

#ifdef __cplusplus
};
#endif

#endif // __GPIO_H
