#ifndef __SYSTICK_H
#define __SYSTICK_H

#ifdef __cplusplus
extern "C" {
#endif
#ifdef __SYSTICK_H_GLOBAL
#define __SYSTICK_H_EXTERN
#else
#define __SYSTICK_H_EXTERN extern
#endif

/************************************************************************************************
 *                                          Version                                             *
 ************************************************************************************************/

/************************************************************************************************
 *                                          How to use                                          *
 ************************************************************************************************/

/************************************************************************************************
 *                                          Enable config                                        *
 ************************************************************************************************/

/************************************************************************************************
 *                                          Includes                                            *
 ************************************************************************************************/

#include <stdint.h>

/************************************************************************************************
 *                                          Defines                                              *
 ************************************************************************************************/

#define SYSTICK_EXT_CLOCK_1MS_CNT (SystemCoreClock / 1000)

/************************************************************************************************
 *                                          Typedefs                                            *
 ************************************************************************************************/

/************************************************************************************************
 *                                          Interfaces                                          *
 ************************************************************************************************/

void     systick_init(void);
void     systick_handler(void);
uint32_t get_systick_ms(void);
uint32_t get_systick_us(void);
void     dev_systick_decrement(void);
void     dev_systick_increase(void);
void     ms_delay(uint8_t ms_time);

#ifdef __cplusplus
};
#endif

#endif // __SYSTICK_H
