#ifndef __UART_TABLE_H
#define __UART_TABLE_H

#ifdef __cplusplus
extern "C" {
#endif
#ifdef __UART_TABLE_H_GLOBAL
#define __UART_TABLE_H_EXTERN
#else
#define __UART_TABLE_H_EXTERN extern
#endif

/************************************************************************************************
 *                                          Version                                             *
 ************************************************************************************************/

/************************************************************************************************
 *                                          How to use                                          *
 ************************************************************************************************/

/************************************************************************************************
 *                                          Enable config                                        *
 ************************************************************************************************/

/************************************************************************************************
 *                                          Includes                                            *
 ************************************************************************************************/
#include "uart_interface.h"
#include <stdint.h>
/************************************************************************************************
 *                                          Defines                                              *
 ************************************************************************************************/

/************************************************************************************************
 *                                          Typedefs                                            *
 ************************************************************************************************/

typedef struct
{
    uint16_t addr;
    void (*p_func)(uint8_t memoft, uint8_t *data, uint8_t *read_bytes);
} regist_read_type;

/************************************************************************************************
 *                                          Interfaces                                          *
 ************************************************************************************************/

uint8_t get_regist_value(uart_type *p_data, uint8_t mem_start_addr, uint8_t read_len);
uint8_t set_regist_value(uart_type *p_data, uint8_t mem_start_addr, uint8_t read_len);

#ifdef __cplusplus
};
#endif

#endif // __UART_TABLE_H
